OdeToFood/Models/CuisineType.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace OdeToFood.Models
{
    public enum CuisineType
    {
        None,
        Italian,
        French,
        German,
        Slovak,
        Czech,
        Chinese,
        Mexican
    }
}

OdeToFood/Models/Restaurant.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.ComponentModel.DataAnnotations;

namespace OdeToFood.Models
{
    public class Restaurant
    {
        public int Id { get; set; }

        [Display(Name="Restaurant Name")]
        [Required, MaxLength(80)]
        public string Name { get; set; }

        public CuisineType Cuisine { get; set; }
    }
}

OdeToFood/ViewModels/HomeIndexViewModel.cs
using OdeToFood.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace OdeToFood.ViewModels
{
    public class HomeIndexViewModel
    {
        public IEnumerable<Restaurant> Restaurants { get; set; }
        public string CurrentMessage { get; set; }
    }
}

OdeToFood/ViewModels/RestaurantEditModel.cs
using OdeToFood.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace OdeToFood.ViewModels
{
    public class RestaurantEditModel
    {
        [Required, MaxLength(80)]
        public string Name { get; set; }
        public CuisineType Cuisine { get; set; }
    }
}

OdeToFood/Controllers/AboutController.cs
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace OdeToFood.Controllers
{
    [Route("[controller]/[action]")]
    public class AboutController
    {

        public string Phone()
        {
            return "+420-745-841-255";
        }

        public string Address()
        {
            return "CZ";
        }
    }
}

OdeToFood/Controllers/AccountController.cs
using Microsoft.AspNetCore.Authentication;
using Microsoft.AspNetCore.Authentication.Cookies;
using Microsoft.AspNetCore.Authentication.OpenIdConnect;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace OdeToFood.Controllers
{
    public class AccountController : Controller
    {
        public IActionResult Login()
        {
            var redirectUrl = Url.Page("/Index");
            return Challenge(
                new AuthenticationProperties { RedirectUri = redirectUrl },
                // challenge the user by logging in with OIDC server
                OpenIdConnectDefaults.AuthenticationScheme
            );
        }

        public IActionResult Logout()
        {
            var callbackUrl = Url.Page("/Account/SignedOut");
            return SignOut(
                new AuthenticationProperties { RedirectUri = callbackUrl },
                // remove cookie that authenticate user
                CookieAuthenticationDefaults.AuthenticationScheme,
                // also logout of OIDC identity provider
                OpenIdConnectDefaults.AuthenticationScheme
            );
        }
    }
}

OdeToFood/Controllers/HomeController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using OdeToFood.Models;
using OdeToFood.Services;
using OdeToFood.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace OdeToFood.Controllers
{
    [Authorize]
    public class HomeController : Controller
    {
        private IRestaurantData _restaurantData;
        private IGreeter _greeter;

        public HomeController(IRestaurantData restaurantData,
                              IGreeter greeter)
        {
            _restaurantData = restaurantData;
            _greeter = greeter;
        }

        [AllowAnonymous]
        public IActionResult Index()
        {
            var model = new HomeIndexViewModel();
            model.Restaurants = _restaurantData.GetAll();
            model.CurrentMessage = _greeter.GetMessageOfTheDay();

            return View(model);
        }

        public IActionResult Details(int id)
        {
            var model = _restaurantData.Get(id);
            if (model == null)
            {
                return RedirectToAction(nameof(Index));
            }
            return View(model);
        }

        [HttpGet]
        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Create(RestaurantEditModel model)
        {
            if (ModelState.IsValid)
            {
                var newRestaurant = new Restaurant();
                newRestaurant.Name = model.Name;
                newRestaurant.Cuisine = model.Cuisine;

                newRestaurant = _restaurantData.Add(newRestaurant);

                return RedirectToAction(nameof(Details), new { id = newRestaurant.Id });
            }
            else
            {
                return View();
            }
        }
    }
}

OdeToFood/Pages/Account/SignedOut.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;

namespace OdeToFood.Pages.Account
{
    public class SignedOutModel : PageModel
    {
        public void OnGet()
        {
        }
    }
}

OdeToFood/Pages/Greeting.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using OdeToFood.Services;

namespace OdeToFood.Pages
{
    public class GreetingModel : PageModel
    {
        private IGreeter _greeter;

        public string CurrentGreeting { get; set; }

        public GreetingModel(IGreeter greeter)
        {
            _greeter = greeter;
        }
        public void OnGet(string name)
        {
            CurrentGreeting = $"{_greeter.GetMessageOfTheDay()} {name}";
        }
    }
}

OdeToFood/Pages/Restaurants/Edit.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using OdeToFood.Services;
using OdeToFood.Models;
using Microsoft.AspNetCore.Authorization;

namespace OdeToFood.Pages.Restaurants
{
    [Authorize]
    public class EditModel : PageModel
    {
        private IRestaurantData _restaurantData;

        [BindProperty]
        public Restaurant Restaurant { get; set; }

        public EditModel(IRestaurantData restaurantData)
        {
            _restaurantData = restaurantData;
        }
        public IActionResult OnGet(int id)
        {
            Restaurant = _restaurantData.Get(id);
            if (Restaurant == null)
            {
                return RedirectToAction("Index", "Home");
            }
            return Page();
        }

        public IActionResult OnPost()
        {
            if (ModelState.IsValid)
            {
                _restaurantData.Update(Restaurant);
                return RedirectToAction("Details", "Home", new { id = Restaurant.Id });
            }
            return Page();
        }
    }
}

OdeToFood/ViewComponents/GreeterViewComponent.cs
using Microsoft.AspNetCore.Mvc;
using OdeToFood.Services;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace OdeToFood.ViewComponents
{
    public class GreeterViewComponent : ViewComponent
    {
        private IGreeter _greeter;

        public GreeterViewComponent(IGreeter greeter)
        {
            _greeter = greeter;
        }

        public IViewComponentResult Invoke()
        {
            var model = _greeter.GetMessageOfTheDay();
            return View("Default", model);
        }
    }
}

OdeToFood/ViewComponents/LoginLogoutViewComponent.cs
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace OdeToFood.ViewComponents
{
    public class LoginLogoutViewComponent : ViewComponent
    {
        public IViewComponentResult Invoke()
        {
            return View();
        }
    }
}

OdeToFood/Pages/Account/SignedOut.cshtml
@page

<div>You are signed out.</div>
<a asp-controller="Home" asp-action="Index">Go Home</a>

OdeToFood/Pages/Greeting.cshtml
@page "{name}"

@model GreetingModel

<div>@Model.CurrentGreeting</div>

OdeToFood/Pages/Restaurants/Edit.cshtml
@page "{id}"
@using OdeToFood.Pages.Restaurants

@model EditModel
@{
}

<h1>Edit @Model.Restaurant.Name</h1>

<form method="post">

    <input type="hidden" asp-for="Restaurant.Id" />

    <div>
        <label asp-for="Restaurant.Name"></label>
        <input asp-for="Restaurant.Name" />
        <span asp-validation-for="Restaurant.Name"></span>
    </div>

    <div>
        <label asp-for="Restaurant.Cuisine"></label>
        <select asp-for="Restaurant.Cuisine" asp-items="@Html.GetEnumSelectList<CuisineType>()"></select>
        <span asp-validation-for="Restaurant.Cuisine"></span>
    </div>

    <input type="submit" name="save" value="Save" />
</form>

OdeToFood/Pages/_Layout.cshtml
<!DOCTYPE html>

<html>
<head>
    <meta name="viewport" content="width=device-width" />
    <title>@ViewBag.Title</title>
</head>
<body>
    <div>
        @RenderBody()
    </div>
    <footer>
        @RenderSection("footer", required:false)
    </footer>
</body>
</html>

OdeToFood/Views/Home/Create.cshtml
@model Restaurant

@{ 
    ViewBag.Title = "Create";
}

<h1>Create</h1>

<form method="post">

    <div>
        <label asp-for="Name"></label>
        <input asp-for="Name" />
        <span asp-validation-for="Name"></span>
    </div>

    <div>
        <label asp-for="Cuisine"></label>
        <select asp-for="Cuisine" asp-items="@Html.GetEnumSelectList<CuisineType>()"></select>
        <span asp-validation-for="Cuisine"></span>
    </div>

    <input type="submit" name="save" value="Save" />
</form>

OdeToFood/Views/Home/Details.cshtml
@model Restaurant

@{ 
    ViewBag.Title = Model.Name;
}

<h1>@Model.Name</h1>

<div>
    Id: @Model.Id
</div>
<div>
    Cuisine: @Model.Cuisine
</div>

<a asp-action="Index" asp-controller="Home">Home</a>

OdeToFood/Views/Home/Index.cshtml
@model HomeIndexViewModel

@{
    ViewBag.Title = "Home page";
}

<h1>@Model.CurrentMessage</h1>

@foreach (var restaurant in Model.Restaurants)
{
    @Html.PartialAsync("_Summary", restaurant)
}

<div><a class="btn btn-primary" asp-action="Create">Add Restaurant</a></div>

OdeToFood/Views/Home/_Summary.cshtml
@model Restaurant

<section class="panel panel-default">
    <h3 class="panel-heading">@Model.Name</h3>
    <div class="panel-body">
        Cuisine: @Model.Cuisine
    </div>
    <div class="panel-footer">
        <a class="btn btn-default" asp-action="Details" asp-route-id="@Model.Id">Details</a>
        <a class="btn btn-default" asp-page="/Restaurants/Edit" asp-route-id="@Model.Id">Edit</a>
    </div>
</section>

OdeToFood/Views/Shared/Components/Greeter/Default.cshtml
@model string
<div>
    @Model
</div>

OdeToFood/Views/Shared/Components/LoginLogout/Default.cshtml
@if (User.Identity.IsAuthenticated)
{
    <div>Hello, @User.Identity.Name</div>
    <a class="btn btn-default" asp-controller="Account" asp-action="Logout">Logout</a>
}
else
{
    <a class="btn btn-default" asp-controller="Account" asp-action="Login">Login</a>
}

OdeToFood/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta name="viewport" content="width=device-width" />
    <title>@ViewBag.Title</title>
    <environment include="Development">
        <link href="~/node_modules/bootstrap/dist/css/bootstrap.css" rel="stylesheet" />
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="http://ajax.aspnetcdn.com/ajax/bootstrap/3.3.7/css/bootstrap.min.css"
              asp-fallback-href="~/node_modules/bootstrap/dist/css/bootstrap.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position"
              asp-fallback-test-value="absolute" />
    </environment>
</head>
<body>
    <nav class="navbar navbar=default">
        <div class="container-fluid">
            <div class="navbar-head">
                <a class="navbar-brand" href="/">OdeToFood</a>
            </div>
            <div class="navbar-right">
                <vc:login-logout></vc:login-logout>
            </div>
        </div>
    </nav>
    <div class="container">
        @RenderBody()
        <footer>
            @RenderSection("footer", required: false)
        </footer>
    </div>
    <script src="~/node_modules/jquery/dist/jquery.js"></script>
    <script src="~/node_modules/jquery-validation/dist/jquery.validate.js"></script>
    <script src="~/node_modules/jquery-validation-unobtrusive/jquery.validate.unobtrusive.js"></script>
</body>
</html>